<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\InsulinRequest;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;

use App\User;
use App\Insulin;

class InsulinController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/insulins';
    /** View folder */
    private $viewDirectory= 'admin.insulins.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('insulins.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the insulins.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    { 
        $ids = Insulin::pluck('user_id');
        $query = User::whereIn('id',$ids)->orderBy('id', 'DESC');

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('name', 'LIKE', '%'.$request->name.'%');
        }


        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $insulins= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('insulins'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('insulins.store');
        $patients = User::where('role_id','6')->get();
        $head = metaFields('insulins', 'add_new', getCurrentLocale()) ?? __('insulins.new');


        return view( $this->viewDirectory.'form', compact('action', 'head','patients') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param InsulinRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(InsulinRequest $request) :RedirectResponse
    {
     
        $this->saveData( $request, $request->user_id );

        
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  Insulin  $insulin
     * @return View
     */
    public function edit(User $insulin): View
    {
        $action= route('insulins.update', $insulin->id);
        $head = metaFields('insulins', 'edit', getCurrentLocale()) ?? __('insulins.edit');
        $patients = User::where('role_id','6')->get();
        $insulins = Insulin::where('user_id',$insulin->id)->get();
        
        return view( $this->viewDirectory.'form', compact('insulin','insulins', 'action', 'head','patients') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  InsulinRequest  $request
     * @param  Insulin  $insulin
     * @return RedirectResponse|Redirector
     */
    public function update(InsulinRequest $request, User $insulin) :RedirectResponse
    {
      
        Insulin::where('user_id',$insulin->id)->delete();
        $this->saveData( $request, $request->user_id );
		
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }
    private function saveData(Request $request, int $id ):void
    {
        
       if (!is_null($request->insulin))
       {
           
            foreach ($request->insulin as $row)
            {
                if(is_null($row['dating'])){
                    $date = date('Y-m-d');
                }
                else{
                    $date = $row['dating'];
                }
              Insulin::create([
            'user_id'=>$id,
            'dating'=>$date,
            'fasting_blood'=>$row['fasting_blood'],
            'fasting_insulin'=>$row['fasting_insulin'],
            'homa_ir'=>$row['homa_ir'],
            'tg_hdl'=>$row['tg_hdl'],
            'hgbaic'=>$row['hgbaic'],
            'waist_circ'=>$row['waist_circ'],
            'resistance'=>$row['resistance'],
           






                                            ]);





            
              
            }
        }

    }
    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $user = Insulin::withTrashed()->find($id);
        if ($user) {
            if ($user->deleted_at) {
                $user->forceDelete();
            } else {
                $user->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            Insulin::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Insulin::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $user = Insulin::withTrashed()->find($id);

        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $user = Insulin::whereIn('id', $request->ids)->onlyTrashed();
        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
